<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:mx="http://www.ibm.com/maximo"
  xmlns:ap="http://www.alarmpoint.com/webservices/schema">

  <!-- The personAction variable controls how synchronization with AlarmPoint is performed, and how the personList will be handled. By default, all Users and their Devices are synchronized (EXCLUDE). This variable must be set to one of the following options:
     - INCLUDE: ONLY the person IDs listed in personList will be synchronized to AlarmPoint.
     - EXCLUDE: All persons will be synchronized to AlarmPoint, except for those listed in personList. 
     -->
  <xsl:variable name="personAction">EXCLUDE</xsl:variable>

  <!-- Add the PERSONID of any users/devices who should be excluded from synchronization with AlarmPoint.  By default all users are synchronized -->
  <xsl:variable name="personList">
    <person>
      <!--mx:PERSONID>BSMITH</mx:PERSONID-->
    </person>
  </xsl:variable>

  <!-- Add the PERSONID of any users/devices who should only be added to AlarmPoint but never updated.  By default all users are updated -->
  <xsl:variable name="seedOnlyList">
    <person>
      <!--mx:PERSONID>BSMITH</mx:PERSONID-->
    </person>
  </xsl:variable>

  <!-- Add the PERSONID of any users/devices that should not be deleted from AlarmPoint.  By default all users are deletable -->
  <xsl:variable name="undeletableList">
    <person>
      <!--mx:PERSONID>BSMITH</mx:PERSONID-->
    </person>
  </xsl:variable>

</xsl:stylesheet>
