<%@page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" %>

<%@page import="com.xmatters.integrations.ws.*" %>
<%@page import="com.xmatters.ibm.tivoli.util.*" %>
<%@page import="org.dom4j.*" %>
<%@page import="java.util.*"%>

<html>
  <head>
    <link rel="stylesheet" type="text/css" href="alarmpoint.css" /> 
    <title>Group Search</title>
    <script language="JavaScript" type="text/javascript">
      function moveToParent(sourceElm){
        for(var i=sourceElm.length-1; i>-1; i--){
          if(sourceElm.options[i].selected){
            opener.addGroup(sourceElm.options[i].text);
            sourceElm.options[i] = null;
          }
        }
      }
    </script>
  </head>
  <h1>Group Search</h1>
  <%@include file="Configuration.jsp"%>
  <%
  String securityOptionName = "XMQM";
  if(updateUserInfo(session) && isInSecurityGroup(securityOptionName)){
  %>
    <body>
    <form name="quickMessage" action="GroupSearch.jsp" method="get">
      <div class="form-row">
        <label>Search Criteria:</label>
        <span>
          <select name="field">
            <option value="PERSONGROUP">Group Name</option>
          </select>
          <input type="text" name="value" value=""/>(Starts With)
        </span>
      </div>
      <div class="form-row">
        <label></label>
        <span>
          <input name="search" type="submit" value="Search"/>
        </span>
      </div>

      <%
      if(request.getParameter("search") != null){
        Map filter = new HashMap();
        filter.put(request.getParameter("field"), request.getParameter("value")+"%");
        Collection groups = getMXObjectValues("PERSONGROUP", "PERSONGROUP", filter);
      %>
        <div class="form-row">
          <label>Groups:</label>
          <span>
            <select size="10" multiple="true" style="width: 200px" name="groups">
              <%
              // If the recipient that should be selected doesn't exist in Maximo add it to the list
              Iterator groupItr =  groups.iterator();
              while(groupItr.hasNext()){
                String group = (String)groupItr.next();
                out.println("<option>"+group+"</option>");
              }
              %>
            </select>
          </span>
        </div>
      <%
      }
      %>
      <div class="form-row">
        <label></label>
        <span>
          <%
          if(request.getParameter("search") != null){
          %>
            <input type="button" value="Add Group" onclick="javascript:{moveToParent(this.form.groups);}"/>
          <%
          }
          %>
          <input type="submit" value="Close" onclick="javascript:{self.close();}" />
        </span>
      </div>
    </body>
  <%
  }else{
  %>
    <body>
      <div class="system-msg-error"><%=errMsg%></div>
      <input type="submit" value="Close" onclick="javascript:{self.close();}" />
    </body>
  <%
  }
  %>
</html>
