<%@page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" %>

<%@page import="com.xmatters.integrations.ws.*" %>
<%@page import="com.xmatters.ibm.tivoli.util.*" %>
<%@page import="org.dom4j.*" %>
<%@page import="java.util.*"%>

<html>
  <head>
    <link rel="stylesheet" type="text/css" href="alarmpoint.css" />
    <title>Send xMatters Quick Message</title>
    <script language="JavaScript" type="text/javascript">
      function popup(url, name){
        child=open(url, name);
        if (child.opener == null)
          child.opener = self;
      }
      function addPerson(person){
        var option = new Option(person, person, false, false);
        var select = document.quickMessage.persons;
        select.options[select.length] = option;
      }
      function addGroup(group){
        var option = new Option(group, group, false, false);
        var select = document.quickMessage.groups;
        select.options[select.length] = option;
      }
      function removeSelected(selectElm)
      {
        for(var i=selectElm.length-1; i>-1; i--){
          if(selectElm.options[i].selected){
            selectElm.options[i] = null;
          }
        }
      }
      function selectPersonsAndGroups(){
        selectAll(document.quickMessage.persons);
        selectAll(document.quickMessage.groups);
      }
      function selectAll(selectElm){
        for(var i=selectElm.length-1; i>-1; i--)
          selectElm.options[i].selected = true
      }
      function ismaxlength(obj){
        var mlength=obj.getAttribute? parseInt(obj.getAttribute("maxlength")) : ""
        if (obj.getAttribute && obj.value.length>mlength)
        obj.value=obj.value.substring(0,mlength)
      }
    </script>
  </head>
  <h1>Send xMatters Quick Message</h1>
  <%@include file="Configuration.jsp"%>
  <%!
  Element createEventTokenElm(AlarmPointWebServiceClient wsClient, String name, String value)
  {
    Element tokenElm = wsClient.createElement("eventToken", null);
    tokenElm.add(wsClient.createElement("name", name));
    tokenElm.add(wsClient.createElement("value", value));
    return tokenElm;
  }
  %>
  <%
  String securityOptionName = "XMQM";
  if(updateUserInfo(session) && isInSecurityGroup(securityOptionName)){
    // Retrieve all of the setup variables
    String incidentId = request.getParameter("incidentId");
    String subject = request.getParameter("subject");
    if(subject == null)
      subject = "";
    String message = request.getParameter("message");
    if(message == null)
      message = "";
    String mxOperator = request.getParameter("operator");
    String person = request.getParameter("person");
    String group = request.getParameter("group");
    // First display the message details page
    if(request.getParameter("send") == null)
    {
    %>
    <body>
    <form name="quickMessage" action="QuickMessage.jsp" method="get">

        <%
        if(incidentId != null){
        %>
          <div class="form-row">
            <label>Incident Number:</label>
            <span>
              <input type="text" name="incidentId" readonly="true" value="<%=incidentId%>"/>
            </span>
          </div>
        <%
        }
        %>

        <div class="form-row">
          <label>Target Groups:</label>
          <span>
            <select size="5" multiple="true" style="width: 200px" name="groups">
              <%
              if(group != null)
                out.println("<option>"+group+"</option>");
              %>
              </select>
          </span>
        </div>
        <div class="form-row">
          <label></label>
          <span>
            <input type="button" value="Add Group" onclick="javascript:{popup('GroupSearch.jsp')}"/>
            <input type="button" value="Remove Selected" onclick="javascript:{removeSelected(this.form.groups);}"/>
          </span>
        </div>

        <div class="form-row">
          <label>Target Users:</label>
          <span>
            <select size="5" multiple="true" style="width: 200px" name="persons">
              <%
              if(person != null)
                out.println("<option>"+person+"</option>");
              %>
            </select>
          </span>
        </div>
        <div class="form-row">
          <label></label>
          <span>
            <input type="button" value="Add Person" onclick="javascript:{popup('PersonSearch.jsp')}"/>
            <input type="button" value="Remove Selected" onclick="javascript:{removeSelected(this.form.persons);}"/>
          </span>
        </div>

        <div class="form-row">
          <label>Subject Text:</label>
          <span>
            <input size="60" MAXLENGTH="60" type="text" name="subject" value="<%=subject%>"/>
          </span>
        </div>

        <div class="form-row">
          <label>Message Text:</label>
          <span>
            <textarea rows="5" cols="60" name="message" maxlength="150" onkeyup="return ismaxlength(this)" onBlur="return ismaxlength(this)"><%=message%></textarea>
          </span>
        </div>

        <%
        if(mxOperator != null){
        %>
          <div class="form-row">
            <label>Operator:</label>
            <span>
              <input type="text" name="operator" readonly="true" value="<%=mxOperator%>"/>
            </span>
          </div>
        <%
        }
        %>
        <div class="form-row">
          <label></label>
          <span>
            <input name="send" type="submit" value="Send" onclick="javascript:{selectPersonsAndGroups();}"/>
            <input type="button" value="Cancel" onclick="javascript:{self.close();}" />
          </span>
        </div>

    </form>
    </body>
    <%
    }
    else
    {
      // Retrieve all of the event tokens from the request
      String recipients = "";
      // Add all of the recipients to the list
      String[] persons = request.getParameterValues("persons");
      if(persons != null){
        for(int i=0; i < persons.length; i++){
          if(!"".equals(recipients))
            recipients += ",";
          recipients += persons[i];
        }
      }
      String[] groups = request.getParameterValues("groups");
      if(groups != null){
        for(int i=0; i < groups.length; i++){
          if(!"".equals(recipients))
            recipients += ",";
          recipients += groups[i];
        }
      }

      // Create the required Elements for the request
      Element[] elements = new Element[1];
      Element eventTokensElm = wsClient.createElement("eventTokens", null);
      // Add all of the event tokens for this event
      eventTokensElm.add(createEventTokenElm(wsClient, "quickmessage", "true"));
      eventTokensElm.add(createEventTokenElm(wsClient, "agent_client_id", "tivoli-srm"));
      if(incidentId != null && !"".equals(incidentId))
        eventTokensElm.add(createEventTokenElm(wsClient, "incident_id", incidentId));
      if(subject != null && !"".equals(subject))
        eventTokensElm.add(createEventTokenElm(wsClient, "subject", subject));
      if(message != null && !"".equals(message))
        eventTokensElm.add(createEventTokenElm(wsClient, "message", message));
      if(mxOperator != null && !"".equals(mxOperator))
        eventTokensElm.add(createEventTokenElm(wsClient, "operator", mxOperator));
      if(recipients != null && !"".equals(recipients))
        eventTokensElm.add(createEventTokenElm(wsClient, "recipients", recipients));
      elements[0] = eventTokensElm;
      // Make the web service request
      String returnStatus = wsClient.sendCheckStatus("AddEvent", elements);
      %>
      <body <%if("OK".equals(returnStatus)) out.println("onload=\"javascript:{self.close();}\"");%>>
        <%
          if("OK".equals(returnStatus))
            out.println("<div class=\"system-msg-success\">Successfully created xMatters notification.</div>");
          else
            out.println("<div class=\"system-msg-error\">Failed to create xMatters notification ["+returnStatus+"].</div>");
        %>
        <input type="submit" value="Close" onclick="javascript:{self.close();}" />
      </body>
      <%
    }
  }else{
  %>
    <body>
      <div class="system-msg-error"><%=errMsg%></div>
      <input type="submit" value="Close" onclick="javascript:{self.close();}" />
    </body>
  <%
  }
  %>
</html>
