<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:mx="http://www.ibm.com/maximo"
  xmlns:ap="http://www.alarmpoint.com/webservices/schema">

  <!-- The groupAction variable controls how synchronization with AlarmPoint is performed, and how the groupList will be handled. By default, all Users and their Devices are synchronized (EXCLUDE). This variable must be set to one of the following options:
     - INCLUDE: ONLY the group IDs listed in groupList will be synchronized to AlarmPoint.
     - EXCLUDE: All groups will be synchronized to AlarmPoint, except for those listed in groupList. 
     -->
  <xsl:variable name="groupAction">EXCLUDE</xsl:variable>

  <!-- Add the PERSONGROUP of any groups who should be excluded from synchronization with AlarmPoint.  By default all groups are synchronized -->
  <xsl:variable name="groupList">
    <group>
      <!--mx:PERSONGROUP>OPERATIONS</mx:PERSONGROUP-->
    </group>
  </xsl:variable>

  <!-- Add the PERSONGROUP of any groups who should be added and updated in AlarmPoint.  By default all groups are synchronized -->
  <xsl:variable name="seedOnlyList">
    <group>
      <!--mx:PERSONGROUP>OPERATIONS</mx:PERSONGROUP-->
    </group>
  </xsl:variable>

  <!-- Add the PERSONGROUP of any groups that should not be deleted from AlarmPoint.  By default all groups are deletable -->
  <xsl:variable name="undeletableList">
    <group>
      <!--mx:PERSONGROUP>OPERATIONS</mx:PERSONGROUP-->
    </group>
  </xsl:variable>

</xsl:stylesheet>